(*
  flatulent
*)

program par;

const arab : set of char = ['0','1','2','3','4','5','6','7','8','9'];
      rim  : set of char = ['I','V','X','L','C','D','M'];
      rim_hod  : array [1..7] of word = (1, 5, 10, 50, 100, 500, 1000);
      rim_cif  : array [1..7] of char = ('I','V','X','L','C','D','M');
      rimava   : string  = 'IVXLCDM';

var vstup,
    vystup : string;
    bulo   : boolean; (* 0 pre arabsky a 1 pre rimsky vstup *)
    i      : byte;

(********************************)
procedure helmuthhelp;
  begin
    writeln;
    writeln ('prevod kladnych celych cisel arabskych na rimske alebo naopak');
    writeln ('retazec cisel (0..9) alebo znakov (IVXLCDM) tvori parameter prikazu');
    writeln ('napriklad [ par XLIV ] vypise rimske cislo XLIV v arabskom tvare 49');
    writeln ('napriklad [ par 49   ] vypise arabske cislo 49 v rimskom tvare XLIV');
    writeln;
    halt (1);
  end;
(********************************)

(********************************)
function a2r (vstup : string) : string;
  var cislo,
      kodak  : word;
      pocet  : array [1..7] of byte;
      pseudo : string;
      j      : byte;

  begin
    pseudo:='';
    for i:=1 to 7 do pocet[i]:=0;
    val (vstup, cislo, kodak);

    for i:=7 downto 1 do begin
      pocet[i]:=cislo div rim_hod[i];
      cislo:=cislo-pocet[i]*rim_hod[i];
    end;

    for i:=7 downto 1 do
      for j:=1 to pocet[i] do
        pseudo:=pseudo+rim_cif[i];

    j:=pos('IIII', pseudo); if j<>0 then begin delete(pseudo, j, 4);
      insert('IV', pseudo, j); end;
    j:=pos('XXXX', pseudo); if j<>0 then begin delete(pseudo, j, 4);
      insert('XL', pseudo, j); end;
    j:=pos('CCCC', pseudo); if j<>0 then begin delete(pseudo, j, 4);
      insert('CD', pseudo, j); end;

    j:=pos('VIV', pseudo); if j<>0 then begin delete(pseudo, j, 3);
      insert('IX', pseudo, j); end;
    j:=pos('LXL', pseudo); if j<>0 then begin delete(pseudo, j, 3);
      insert('XC', pseudo, j); end;
    j:=pos('DCD', pseudo); if j<>0 then begin delete(pseudo, j, 3);
      insert('CM', pseudo, j); end;

    a2r:=pseudo;
      
  end;
(********************************)

(********************************)
function r2a (vstup : string) : string;
  var       j      : byte;
            pompo  : word;
            s,
            pseudo : string;

  begin
    pseudo:=vstup;

    j:=pos('IX', pseudo); if j<>0 then begin delete(pseudo, j, 2);
      insert('VIV', pseudo, j); end;
    j:=pos('XC', pseudo); if j<>0 then begin delete(pseudo, j, 2);
      insert('LXL', pseudo, j); end;
    j:=pos('CM', pseudo); if j<>0 then begin delete(pseudo, j, 2);
      insert('DCD', pseudo, j); end;

    j:=pos('IV', pseudo); if j<>0 then begin delete(pseudo, j, 2);
      insert('IIII', pseudo, j); end;
    j:=pos('XL', pseudo); if j<>0 then begin delete(pseudo, j, 2);
      insert('XXXX', pseudo, j); end;
    j:=pos('CD', pseudo); if j<>0 then begin delete(pseudo, j, 2);
      insert('CCCC', pseudo, j); end;

    pompo:=0;
      for i:=1 to length (pseudo) do
        pompo:=pompo+rim_hod[pos(pseudo[i], rimava)];

    str (pompo, s);

    pseudo:=a2r(s);
    if pseudo<>vstup then begin
      writeln ('parameter nie je zadany korektne - rimske cisla v nespravnom poradi');
      writeln ('pouzi prepinac --help');
      halt (1);
    end;
      

    r2a:=s;

  end;
(********************************)


begin

  if paramstr(1)='--help' then helmuthhelp;

  if paramcount<1 then begin
    writeln ('ziadny parameter');
    writeln ('pouzi prepinac --help');
    halt (1);
  end;

  if paramcount>1 then begin
    writeln ('privela parametrov');
    writeln ('pouzi prepinac --help');
    halt (1);
  end;

  vstup:=paramstr(1);

  for i:=1 to length (vstup) do
    if not ((vstup[i] in arab) or (vstup[i] in rim)) then begin
      writeln ('parameter nie je zadany korektne - divne znaky');
      writeln ('pouzi prepinac --help');
      halt (1);
    end;

  bulo:=false;
  for i:=1 to length (vstup) do
    if not (vstup[i] in arab) then bulo:=true;

  if bulo=true then
    for i:=1 to length (vstup) do
    if not (vstup[i] in rim) then begin
      writeln ('parameter nie je zadany korektne -  arabskorimska miesanina');
      writeln ('pouzi prepinac --help');
      halt (1);
    end;

  vystup:='';
  if bulo=false then vystup:=a2r (vstup)
  else vystup:=r2a (vstup);

  writeln (vstup, '  ', vystup);
  writeln;
end.
